function T = dynamic_g1_tt(T, y, x, params, steady_state, it_)
% function T = dynamic_g1_tt(T, y, x, params, steady_state, it_)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double  vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double  vector of endogenous variables in the order stored
%                                                    in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double  matrix of exogenous variables (in declaration order)
%                                                    for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double  vector of steady state values
%   params        [M_.param_nbr by 1]        double  vector of parameter values in declaration order
%   it_           scalar                     double  time period for exogenous variables for which
%                                                    to evaluate the model
%
% Output:
%   T           [#temp variables by 1]       double  vector of temporary terms
%

assert(length(T) >= 50);

T = RANK_q4.dynamic_resid_tt(T, y, x, params, steady_state, it_);

T(41) = getPowerDeriv(y(2),params(5)-1,1);
T(42) = getPowerDeriv(y(2),params(5),1);
T(43) = getPowerDeriv(y(24)*y(2),params(5),2);
T(44) = getPowerDeriv(y(16)*y(57),params(5),2);
T(45) = getPowerDeriv(y(18),1-params(5),2);
T(46) = y(45)*(-(T(23)*params(21)*y(2)*T(31)))+y(36)*(-(params(22)*y(31)*T(23)*T(4)*params(5)*params(21)*T(32)))+y(35)*(-(y(31)*T(25)*T(2)*(1-params(5))*params(21)*T(32)));
T(47) = getPowerDeriv(y(54),1-params(5),1);
T(48) = y(48)*(-(params(8)*(-T(28))))+y(46)*T(28)+y(38)*T(28)+T(22)*y(13)*params(15)*(-(1/(params(8)*y(4))));
T(49) = getPowerDeriv(y(24),params(5),2);
T(50) = getPowerDeriv(y(57),params(5),1);

end
