function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
% function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double   vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double   vector of endogenous variables in the order stored
%                                                     in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double   matrix of exogenous variables (in declaration order)
%                                                     for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double   vector of steady state values
%   params        [M_.param_nbr by 1]        double   vector of parameter values in declaration order
%   it_           scalar                     double   time period for exogenous variables for which
%                                                     to evaluate the model
%   T_flag        boolean                    boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   residual
%

if T_flag
    T = RANK_q4.dynamic_resid_tt(T, y, x, params, steady_state, it_);
end
residual = zeros(39, 1);
residual(1) = y(35)+y(39);
residual(2) = y(44)*params(15)*y(56)+(y(28)-1-(y(30)-params(3))*params(19))*y(43)+y(42)+(-y(41))-y(40);
residual(3) = y(37)+params(23)*y(62)*(-(y(61)*T(11)*T(14)))+params(23)*y(63)*(-(params(22)*y(61)*T(15)*T(17)))+params(23)*y(64)*(-(1+params(8)*(y(60)-params(3))))+params(23)*y(65)*(y(60)+T(18))+params(23)*y(66)*(-(T(15)*T(20)))+params(23)*y(67)*(-(y(58)*y(60)-y(60)-T(18)+y(59)/params(22)-y(59)))+params(23)*y(68)*(-(params(8)*(-(y(60)+T(18)))));
residual(4) = 1/y(17)+params(8)*y(48)+y(41)*T(21)+y(38)+y(39)*(-T(9))+T(22)*y(10)*1/(params(8)*y(3));
residual(5) = y(45)*(-(T(10)*T(23)))+y(39)*(-(y(17)*T(24)))+y(36)*(-(params(22)*y(31)*T(1)*params(5)*params(21)*T(4)*T(23)))+y(35)*(-(y(31)*(1-params(5))*params(21)*T(1)*T(2)*T(25)))-params(11)*getPowerDeriv(y(18),1+params(10),1)/(1+params(10));
residual(6) = y(40);
residual(7) = y(48)*(-(params(8)*(1-T(8))))+y(46)*(-(1-y(31)-T(8)))+y(45)+y(44)*T(26)+y(38)*(-(1-T(8)))+T(22)*y(13)*params(15)*y(22)*(-(1/(params(8)*y(4))));
residual(8) = y(44)*(-y(33))+y(34)*T(27);
residual(9) = y(48)*(-(params(8)*(-T(29))))+y(46)*T(29)+y(44)*(-((-params(15))/params(8)))+y(38)*T(29)-y(40)+T(22)*y(13)*T(30);
residual(10) = y(46);
residual(11) = y(49)+y(45)*(-(T(5)*params(21)*y(2)*T(31)))+y(36)*(-(params(22)*y(31)*T(5)*T(4)*params(5)*params(21)*T(32)))+y(35)*(-(y(31)*T(3)*T(2)*(1-params(5))*params(21)*T(32)))+params(23)*y(69)*(-T(33));
residual(12) = y(47);
residual(13) = y(50)+y(41)+params(23)*y(70)*(-(1-params(8)*params(16)));
residual(14) = y(48);
residual(15) = y(46)*(-(y(2)*y(30)))+y(43)*T(34)+y(42)*T(35)+T(22)*y(11)*(-(T(36)/(y(28)*y(28))))+T(22)*y(12)*(-(1/params(8)));
residual(16) = y(46)*T(37)+y(36)+T(22)*y(11)*(-(1/y(28)));
residual(17) = y(48)*(-(params(8)*(-(y(2)*(1+T(6)*2*(y(30)-params(3)))))))+y(46)*(-(y(2)*(y(28)-1-T(6)*2*(y(30)-params(3)))))+y(43)*T(38)+y(38)*y(2)*(1+T(6)*2*(y(30)-params(3)))+y(37)*(-(y(2)*params(8)))+T(22)*y(12)*params(19)/params(8);
residual(18) = y(20)*y(46)+y(36)*(-(T(1)*params(5)*params(21)*T(4)*T(5)*params(22)))+y(34)+y(35)*(-((1-params(5))*params(21)*T(1)*T(2)*T(3)));
residual(19) = y(51)+y(46)+params(23)*(-(1-params(8)*params(16)))*y(71);
residual(20) = y(52)+y(44)*T(40)+params(23)*(-(1-params(8)*params(16)))*y(72);
residual(21) = y(31)-y(21)/((params(12)-1)/params(12));
residual(22) = y(14)-y(31)*(1-params(5))*params(21)*T(1)*T(2)*T(3);
residual(23) = y(29)-y(31)*T(1)*params(5)*params(21)*T(4)*T(5)*params(22);
residual(24) = y(16)-(y(2)+y(2)*(y(30)-params(3))*params(8));
residual(25) = y(17)-(y(20)-(y(2)*(y(30)+T(7))+y(20)*T(8)));
residual(26) = y(14)-y(17)*T(9);
residual(27) = y(19)-(y(22)+y(15));
residual(28) = (y(53)-y(17))/(params(8)*y(17))-(y(15)-y(26));
residual(29) = y(15)-(y(59)-params(3)*y(58)+(y(58)-y(28))/params(8))/y(58);
residual(30) = (y(15)-(y(30)-params(3)))*(y(28)-1-(y(30)-params(3))*params(19))+y(30)*y(28)-y(30)-T(7)-((y(58)-y(28))/params(8)-params(19)*(y(60)-y(30))/params(8));
residual(31) = params(15)*(y(15)-(y(55)-y(20))/(params(8)*y(20)))*y(56)-(y(33)*(y(21)-(y(33)-1)/y(33))+params(15)*(y(56)-y(22))/params(8));
residual(32) = y(20)-T(5)*T(10);
residual(33) = y(23)-(y(20)*(1-y(31))-y(20)*T(8)-y(32)+y(2)*(y(30)*y(28)-y(30)-T(7))+y(2)*(y(29)/params(22)-y(29)));
residual(34) = y(25);
residual(35) = y(27)-params(8)*(y(20)-(y(2)*(y(30)+T(7))+y(20)*T(8))-y(17));
residual(36) = y(24)-exp((1-params(8)*params(16))*log(y(5)));
residual(37) = y(26)-((1-params(8)*params(16))*y(6)+params(8)*params(16)*params(2));
residual(38) = y(32)-(1-params(8)*params(16))*y(8);
residual(39) = y(33)-((1-params(8)*params(16))*y(9)+params(12)*params(8)*params(16));

end
