function T = dynamic_resid_tt(T, y, x, params, steady_state, it_)
% function T = dynamic_resid_tt(T, y, x, params, steady_state, it_)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double  vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double  vector of endogenous variables in the order stored
%                                                    in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double  matrix of exogenous variables (in declaration order)
%                                                    for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double  vector of steady state values
%   params        [M_.param_nbr by 1]        double  vector of parameter values in declaration order
%   it_           scalar                     double  time period for exogenous variables for which
%                                                    to evaluate the model
%
% Output:
%   T           [#temp variables by 1]       double  vector of temporary terms
%

assert(length(T) >= 40);

T(1) = y(24)^params(5);
T(2) = y(2)^params(5);
T(3) = y(18)^(-params(5));
T(4) = y(2)^(params(5)-1);
T(5) = y(18)^(1-params(5));
T(6) = params(19)/2;
T(7) = T(6)*(y(30)-params(3))^2;
T(8) = params(15)/2*y(22)^2;
T(9) = params(11)*y(18)^params(10);
T(10) = params(21)*(y(24)*y(2))^params(5);
T(11) = y(54)^(-params(5));
T(12) = y(57)^params(5);
T(13) = getPowerDeriv(y(16),params(5),1);
T(14) = (1-params(5))*params(21)*T(12)*T(13);
T(15) = y(54)^(1-params(5));
T(16) = getPowerDeriv(y(16),params(5)-1,1);
T(17) = params(5)*params(21)*T(12)*T(16);
T(18) = T(6)*(y(60)-params(3))^2;
T(19) = getPowerDeriv(y(16)*y(57),params(5),1);
T(20) = params(21)*y(57)*T(19);
T(21) = ((-(params(8)*y(17)))-params(8)*(y(53)-y(17)))/(params(8)*y(17)*params(8)*y(17));
T(22) = params(23)^(-1);
T(23) = getPowerDeriv(y(18),1-params(5),1);
T(24) = params(11)*getPowerDeriv(y(18),params(10),1);
T(25) = getPowerDeriv(y(18),(-params(5)),1);
T(26) = params(15)*y(56)*(-(((-(params(8)*y(20)))-params(8)*(y(55)-y(20)))/(params(8)*y(20)*params(8)*y(20))));
T(27) = (-(1/((params(12)-1)/params(12))));
T(28) = params(15)/2*2*y(22);
T(29) = y(20)*T(28);
T(30) = params(15)*(y(1)-(y(20)-y(4))/(params(8)*y(4)))-params(15)/params(8);
T(31) = getPowerDeriv(y(24)*y(2),params(5),1);
T(32) = getPowerDeriv(y(24),params(5),1);
T(33) = exp((1-params(8)*params(16))*log(y(24)))*(1-params(8)*params(16))*1/y(24);
T(34) = y(30)+y(15)-(y(30)-params(3))-(-1)/params(8);
T(35) = (-((-1)/params(8)/y(58)));
T(36) = y(28)*(1/params(8)-params(3))-(y(29)-params(3)*y(28)+(y(28)-y(7))/params(8));
T(37) = (-(y(2)*(1/params(22)-1)));
T(38) = y(28)-1-T(6)*2*(y(30)-params(3))+(y(15)-(y(30)-params(3)))*(-params(19))-(y(28)-1-(y(30)-params(3))*params(19))+(-params(19))/params(8);
T(39) = (y(33)-(y(33)-1))/(y(33)*y(33));
T(40) = (-(y(21)-(y(33)-1)/y(33)+y(33)*(-T(39))));

end
